# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ExperimentDto(Model):
    """ExperimentDto.

    :param all_jobs_generated:
    :type all_jobs_generated: bool
    :param cancellation_requested:
    :type cancellation_requested: bool
    :param created:
    :type created: datetime
    :param created_by_user_id:
    :type created_by_user_id: int
    :param description:
    :type description: str
    :param experiment_id:
    :type experiment_id: object
    :param experiment_uri:
    :type experiment_uri: str
    :param generator_config:
    :type generator_config: ~hyperdrive.models.ExperimentDtoGeneratorConfig
    :param max_concurrent_jobs:
    :type max_concurrent_jobs: int
    :param max_duration_minutes:
    :type max_duration_minutes: int
    :param max_total_jobs:
    :type max_total_jobs: int
    :param modified:
    :type modified: datetime
    :param name:
    :type name: str
    :param platform:
    :type platform: str
    :param platform_config:
    :type platform_config: object
    :param policy_config:
    :type policy_config: ~hyperdrive.models.ExperimentDtoPolicyConfig
    :param primary_metric_config:
    :type primary_metric_config:
     ~hyperdrive.models.ExperimentDtoPrimaryMetricConfig
    :param resume_from:
    :type resume_from: list[~hyperdrive.models.RunKey]
    :param resume_child_runs:
    :type resume_child_runs: list[~hyperdrive.models.RunKey]
    :param status:
    :type status: str
    :param study_id:
    :type study_id: int
    :param study_uri:
    :type study_uri: str
    :param hyperdrive_run_id:
    :type hyperdrive_run_id: str
    """

    _validation = {
        'all_jobs_generated': {'required': True},
        'cancellation_requested': {'required': True},
        'created': {'required': True},
        'created_by_user_id': {'required': True},
        'experiment_id': {'required': True},
        'generator_config': {'required': True},
        'modified': {'required': True},
        'name': {'required': True},
        'platform': {'required': True},
        'platform_config': {'required': True},
        'policy_config': {'required': True},
        'primary_metric_config': {'required': True},
        'status': {'required': True},
        'study_id': {'required': True},
        'hyperdrive_run_id': {'required': True},
    }

    _attribute_map = {
        'all_jobs_generated': {'key': 'all_jobs_generated', 'type': 'bool'},
        'cancellation_requested': {'key': 'cancellation_requested', 'type': 'bool'},
        'created': {'key': 'created', 'type': 'iso-8601'},
        'created_by_user_id': {'key': 'created_by_user_id', 'type': 'int'},
        'description': {'key': 'description', 'type': 'str'},
        'experiment_id': {'key': 'experiment_id', 'type': 'object'},
        'experiment_uri': {'key': 'experiment_uri', 'type': 'str'},
        'generator_config': {'key': 'generator_config', 'type': 'ExperimentDtoGeneratorConfig'},
        'max_concurrent_jobs': {'key': 'max_concurrent_jobs', 'type': 'int'},
        'max_duration_minutes': {'key': 'max_duration_minutes', 'type': 'int'},
        'max_total_jobs': {'key': 'max_total_jobs', 'type': 'int'},
        'modified': {'key': 'modified', 'type': 'iso-8601'},
        'name': {'key': 'name', 'type': 'str'},
        'platform': {'key': 'platform', 'type': 'str'},
        'platform_config': {'key': 'platform_config', 'type': 'object'},
        'policy_config': {'key': 'policy_config', 'type': 'ExperimentDtoPolicyConfig'},
        'primary_metric_config': {'key': 'primary_metric_config', 'type': 'ExperimentDtoPrimaryMetricConfig'},
        'resume_from': {'key': 'resume_from', 'type': '[RunKey]'},
        'resume_child_runs': {'key': 'resume_child_runs', 'type': '[RunKey]'},
        'status': {'key': 'status', 'type': 'str'},
        'study_id': {'key': 'study_id', 'type': 'int'},
        'study_uri': {'key': 'study_uri', 'type': 'str'},
        'hyperdrive_run_id': {'key': 'hyperdrive_run_id', 'type': 'str'},
    }

    def __init__(self, all_jobs_generated, cancellation_requested, created, created_by_user_id, experiment_id, generator_config, modified, name, platform, platform_config, policy_config, primary_metric_config, status, study_id, hyperdrive_run_id, description=None, experiment_uri=None, max_concurrent_jobs=None, max_duration_minutes=None, max_total_jobs=None, resume_from=None, resume_child_runs=None, study_uri=None):
        super(ExperimentDto, self).__init__()
        self.all_jobs_generated = all_jobs_generated
        self.cancellation_requested = cancellation_requested
        self.created = created
        self.created_by_user_id = created_by_user_id
        self.description = description
        self.experiment_id = experiment_id
        self.experiment_uri = experiment_uri
        self.generator_config = generator_config
        self.max_concurrent_jobs = max_concurrent_jobs
        self.max_duration_minutes = max_duration_minutes
        self.max_total_jobs = max_total_jobs
        self.modified = modified
        self.name = name
        self.platform = platform
        self.platform_config = platform_config
        self.policy_config = policy_config
        self.primary_metric_config = primary_metric_config
        self.resume_from = resume_from
        self.resume_child_runs = resume_child_runs
        self.status = status
        self.study_id = study_id
        self.study_uri = study_uri
        self.hyperdrive_run_id = hyperdrive_run_id
